DCMTK Version 3.7.0 OFFIS DICOM Toolkit

Public Member Functions | Private Member Functions | Private Attributes | List of all members
DVPSOverlayCurveActivationLayer_PList Class Reference

the list of curve and overlay activation layers contained in a presentation state (internal use only). More...

## Public Member Functions
| DVPSOverlayCurveActivationLayer_PList ()
| default constructor
| DVPSOverlayCurveActivationLayer_PList (const DVPSOverlayCurveActivationLayer_PList &copy)
| copy constructor
DVPSOverlayCurveActivationLayer_PList * | clone ()
| clone method. More...
virtual | ~DVPSOverlayCurveActivationLayer_PList ()
| destructor
OFCondition | read (DcmItem &dset)
| reads the curve and overlay activations from a DICOM dataset. More...
OFCondition | write (DcmItem &dset)
| writes the curve and overlay activations managed by this object to a DICOM dataset. More...
void | clear ()
| reset the object to initial state. More...
OFCondition | createFromImage (DcmItem &dset, DVPSGraphicLayer_PList &gLayerList, DVPSOverlay_PList &overlayList, DVPSoverlayActivation overlayActivation, OFBool curveActivation, DVPSGraphicLayering layering)
| create graphic layers and activations for DICOM image. More...
OFCondition | setActivation (Uint16 group, const char *layer)
| set activation layer for given repeating group. More...
void | removeActivation (Uint16 group)
| remove activation for given repeating group.
const char * | getActivationLayer (Uint16 group)
| get activation layer name of the given repeating group. More...
void | renameLayer (const char *oldName, const char *newName)
| renames the activation layer name in all activations with a matching old activation layer name. More...
void | removeLayer (const char *name)
| deletes all activation belonging to the given activation layer name. More...
OFBool | usesLayerName (const char *name)
| checks if the given layer name is used for any of the activation layers managed by this object. More...
size_t | getNumberOfActivations (const char *layer, OFBool isCurve)
| returns the number of activations for the given graphic layer and object type (curve or overlay). More...
Uint16 | getActivationGroup (const char *layer, size_t idx, OFBool isCurve)
| gets the repeating group of the overlay/curve activation with the given index on the given layer. More...

## Private Member Functions
DVPSOverlayCurveActivationLayer_PList & | operator= (const DVPSOverlayCurveActivationLayer_PList &)
| private undefined assignment operator

## Private Attributes
OFList< DVPSOverlayCurveActivationLayer * > | list_
| the list maintained by this object

## Detailed Description

the list of curve and overlay activation layers contained in a presentation state (internal use only).

This class manages the data structures comprising the list of curve activation layers and overlay activation layers (all instances of the Curve Activation Layer Module and Overlay Activation Layer Module repeating elements) contained in a Presentation State object.

## Member Function Documentation

## ◆ clear()

void DVPSOverlayCurveActivationLayer_PList::clear | ( |  | ) |

reset the object to initial state.

After this call, the object is in the same state as after creation with the default constructor.

## ◆ clone()

DVPSOverlayCurveActivationLayer_PList* DVPSOverlayCurveActivationLayer_PList::clone | ( |  | ) |
| inline

clone method.

Returns
  a pointer to a new DVPSOverlayCurveActivationLayer_PList object containing a deep copy of this object.

## ◆ createFromImage()

OFCondition DVPSOverlayCurveActivationLayer_PList::createFromImage | ( | DcmItem & | dset,
|  | DVPSGraphicLayer_PList & | gLayerList,
|  | DVPSOverlay_PList & | overlayList,
|  | DVPSoverlayActivation | overlayActivation,
|  | OFBool | curveActivation,
|  | DVPSGraphicLayering | layering
| ) |  |

create graphic layers and activations for DICOM image.

This method is used when a default presentation state for a DICOM image is created. Depending on the given flags, graphic layer and curve/overlay activations for the curves and overlays present in the DICOM dataset are created. If this method returns an error code, the object is in undefined state afterwards.

Parameters

  dset | the DICOM dataset containing the image IOD
  gLayerList | the list of graphic layers to be created
  overlayList | the list of overlays internal to the presentation state
  overlayActivation | flag defining how overlays should be handled
  curveActivation | flag defining how curves should be handled
  layering | flag defining how graphic layers should be created

Returns
  EC_Normal upon success, an error code otherwise.

## ◆ getActivationGroup()

Uint16 DVPSOverlayCurveActivationLayer_PList::getActivationGroup | ( | const char * | layer,
|  | size_t | idx,
|  | OFBool | isCurve
| ) |  |

gets the repeating group of the overlay/curve activation with the given index on the given layer.

If the activation or the graphic layer does not exist, 0 is returned.

Parameters

  layer | name of the graphic layer
  idx | index of the object, must be < getNumberOfActivations(layer, isCurve)
  isCurve | if OFTrue, curves are searched, otherwise overlays are searched.

Returns
  the repeating group number of the activation

## ◆ getActivationLayer()

const char* DVPSOverlayCurveActivationLayer_PList::getActivationLayer | ( | Uint16 | group | ) |

get activation layer name of the given repeating group.

Returns
  a pointer to the activation layer name if found, NULL otherwise.

## ◆ getNumberOfActivations()

size_t DVPSOverlayCurveActivationLayer_PList::getNumberOfActivations | ( | const char * | layer,
|  | OFBool | isCurve
| ) |  |

returns the number of activations for the given graphic layer and object type (curve or overlay).

This method does not check whether an image object is attached to the presentation state and if all activations really have a matching curve structure in the attached image.

Parameters

  layer | name of the graphic layer
  isCurve | if OFTrue, curves are counted, otherwise overlays are counted.

Returns
  number of curves or overlays on the given layer.

## ◆ read()

OFCondition DVPSOverlayCurveActivationLayer_PList::read | ( | DcmItem & | dset | ) |

reads the curve and overlay activations from a DICOM dataset.

The DICOM elements of the activations are copied from the dataset to this object. If this method returns an error code, the object is in undefined state afterwards.

Parameters

  dset | the DICOM dataset from which the activations are to be read

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ removeLayer()

void DVPSOverlayCurveActivationLayer_PList::removeLayer | ( | const char * | name | ) |

deletes all activation belonging to the given activation layer name.

Parameters

  name | name of the deleted activation layer

## ◆ renameLayer()

void DVPSOverlayCurveActivationLayer_PList::renameLayer | ( | const char * | oldName,
|  | const char * | newName
| ) |  |

renames the activation layer name in all activations with a matching old activation layer name.

Required to keep the presentation consistent when a graphic layer is renamed.

Parameters

  oldName | the old activation layer name
  newName | the new activation layer name

## ◆ setActivation()

OFCondition DVPSOverlayCurveActivationLayer_PList::setActivation | ( | Uint16 | group,
|  | const char * | layer
| ) |  |

set activation layer for given repeating group.

The activation is created if necessary and the layer name is assigned. This method check if a valid repeating group number is passed and returns an error code otherwise.

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ usesLayerName()

OFBool DVPSOverlayCurveActivationLayer_PList::usesLayerName | ( | const char * | name | ) |

checks if the given layer name is used for any of the activation layers managed by this object.

Parameters

  name | name of the layer

Returns
  OFTrue if name is used

## ◆ write()

OFCondition DVPSOverlayCurveActivationLayer_PList::write | ( | DcmItem & | dset | ) |

writes the curve and overlay activations managed by this object to a DICOM dataset.

Copies of the DICOM elements managed by this object are inserted into the DICOM dataset.

Parameters

  dset | the DICOM dataset to which the activations are written

Returns
  EC_Normal if successful, an error code otherwise.

The documentation for this class was generated from the following file:

- dcmpstat/include/dcmtk/dcmpstat/dvpsall.h

Generated on Mon Dec 15 2025 for DCMTK Version 3.7.0 by Doxygen 1.9.1